// Code generated by cmd/generate/main.go; DO NOT EDIT.

package characteristic

type AccessoryFlags_Type uint32

const AccessoryFlags_RequiresAdditionalSetup = AccessoryFlags_Type(1 << 0)

var AccessoryFlags_Meta = Metadata[uint32]{
	Typ: "A6",
}

// AccessoryFlags represents a Accessory Flags characteristic (A6)
//
// UUID: 000000A6-0000-1000-8000-0026BB765291.
func AccessoryFlags(value AccessoryFlags_Type) *Updatable[uint32] {
	static := Static[uint32]{
		Metadata: AccessoryFlags_Meta,
		value:    uint32(value),
	}
	return &Updatable[uint32]{
		Static: static,
	}
}

type Active_Type uint8

const Active_Inactive = Active_Type(0)
const Active_Active = Active_Type(1)

var Active_Meta = Metadata[uint8]{
	Typ: "B0",
}

// Active represents a Active characteristic (B0)
//
// UUID: 000000B0-0000-1000-8000-0026BB765291.
func Active(value Active_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: Active_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

var ActiveIdentifier_Meta = Metadata[uint32]{
	Typ: "E7",
	MinValue: ValuePointer[uint32](0),
}

// ActiveIdentifier represents a Active Identifier characteristic (E7)
//
// UUID: 000000E7-0000-1000-8000-0026BB765291.
func ActiveIdentifier(value uint32, controllerWrite func(uint32) error) *Writable[uint32] {
	static := Static[uint32]{
		Metadata: ActiveIdentifier_Meta,
		value:    value,
	}
	return &Writable[uint32]{
		Updatable: Updatable[uint32]{Static: static},
		write: controllerWrite,
	}
}

var AdministratorOnlyAccess_Meta = Metadata[bool]{
	Typ: "1",
}

// AdministratorOnlyAccess represents a Administrator Only Access characteristic (1)
//
// UUID: 00000001-0000-1000-8000-0026BB765291.
func AdministratorOnlyAccess(value bool, controllerWrite func(bool) error) *Writable[bool] {
	static := Static[bool]{
		Metadata: AdministratorOnlyAccess_Meta,
		value:    value,
	}
	return &Writable[bool]{
		Updatable: Updatable[bool]{Static: static},
		write: controllerWrite,
	}
}

var AirParticulateDensity_Meta = Metadata[float64]{
	Typ: "64",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](1000),
	MinStep: 1,
}

// AirParticulateDensity represents a Air Particulate Density characteristic (64)
//
// UUID: 00000064-0000-1000-8000-0026BB765291.
func AirParticulateDensity(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: AirParticulateDensity_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

type AirParticulateSize_Type uint8

const AirParticulateSize_25M = AirParticulateSize_Type(0)
const AirParticulateSize_10M = AirParticulateSize_Type(1)

var AirParticulateSize_Meta = Metadata[uint8]{
	Typ: "65",
}

// AirParticulateSize represents a Air Particulate Size characteristic (65)
//
// UUID: 00000065-0000-1000-8000-0026BB765291.
func AirParticulateSize(value AirParticulateSize_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: AirParticulateSize_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type AirQuality_Type uint8

const AirQuality_Unknown = AirQuality_Type(0)
const AirQuality_Excellent = AirQuality_Type(1)
const AirQuality_Good = AirQuality_Type(2)
const AirQuality_Fair = AirQuality_Type(3)
const AirQuality_Inferior = AirQuality_Type(4)
const AirQuality_Poor = AirQuality_Type(5)

var AirQuality_Meta = Metadata[uint8]{
	Typ: "95",
}

// AirQuality represents a Air Quality characteristic (95)
//
// UUID: 00000095-0000-1000-8000-0026BB765291.
func AirQuality(value AirQuality_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: AirQuality_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var AudioFeedback_Meta = Metadata[bool]{
	Typ: "5",
}

// AudioFeedback represents a Audio Feedback characteristic (5)
//
// UUID: 00000005-0000-1000-8000-0026BB765291.
func AudioFeedback(value bool, controllerWrite func(bool) error) *Writable[bool] {
	static := Static[bool]{
		Metadata: AudioFeedback_Meta,
		value:    value,
	}
	return &Writable[bool]{
		Updatable: Updatable[bool]{Static: static},
		write: controllerWrite,
	}
}

var BatteryLevel_Meta = Metadata[uint8]{
	Typ: "68",
	Unit: "percentage",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](100),
	MinStep: 1,
}

// BatteryLevel represents a Battery Level characteristic (68)
//
// UUID: 00000068-0000-1000-8000-0026BB765291.
func BatteryLevel(value uint8) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: BatteryLevel_Meta,
		value:    value,
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var Brightness_Meta = Metadata[int32]{
	Typ: "8",
	Unit: "percentage",
	MinValue: ValuePointer[int32](0),
	MaxValue: ValuePointer[int32](100),
	MinStep: 1,
}

// Brightness represents a Brightness characteristic (8)
//
// UUID: 00000008-0000-1000-8000-0026BB765291.
func Brightness(value int32, controllerWrite func(int32) error) *Writable[int32] {
	static := Static[int32]{
		Metadata: Brightness_Meta,
		value:    value,
	}
	return &Writable[int32]{
		Updatable: Updatable[int32]{Static: static},
		write: controllerWrite,
	}
}

type CarbonDioxideDetected_Type uint8

const CarbonDioxideDetected_CO2LevelsNormal = CarbonDioxideDetected_Type(0)
const CarbonDioxideDetected_CO2LevelsAbnormal = CarbonDioxideDetected_Type(1)

var CarbonDioxideDetected_Meta = Metadata[uint8]{
	Typ: "92",
}

// CarbonDioxideDetected represents a Carbon Dioxide Detected characteristic (92)
//
// UUID: 00000092-0000-1000-8000-0026BB765291.
func CarbonDioxideDetected(value CarbonDioxideDetected_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CarbonDioxideDetected_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var CarbonDioxideLevel_Meta = Metadata[float64]{
	Typ: "93",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100000),
}

// CarbonDioxideLevel represents a Carbon Dioxide Level characteristic (93)
//
// UUID: 00000093-0000-1000-8000-0026BB765291.
func CarbonDioxideLevel(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: CarbonDioxideLevel_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

var CarbonDioxidePeakLevel_Meta = Metadata[float64]{
	Typ: "94",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100000),
}

// CarbonDioxidePeakLevel represents a Carbon Dioxide Peak Level characteristic (94)
//
// UUID: 00000094-0000-1000-8000-0026BB765291.
func CarbonDioxidePeakLevel(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: CarbonDioxidePeakLevel_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

type CarbonMonoxideDetected_Type uint8

const CarbonMonoxideDetected_COLevelsNormal = CarbonMonoxideDetected_Type(0)
const CarbonMonoxideDetected_COLevelsAbnormal = CarbonMonoxideDetected_Type(1)

var CarbonMonoxideDetected_Meta = Metadata[uint8]{
	Typ: "69",
}

// CarbonMonoxideDetected represents a Carbon Monoxide Detected characteristic (69)
//
// UUID: 00000069-0000-1000-8000-0026BB765291.
func CarbonMonoxideDetected(value CarbonMonoxideDetected_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CarbonMonoxideDetected_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var CarbonMonoxideLevel_Meta = Metadata[float64]{
	Typ: "90",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
}

// CarbonMonoxideLevel represents a Carbon Monoxide Level characteristic (90)
//
// UUID: 00000090-0000-1000-8000-0026BB765291.
func CarbonMonoxideLevel(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: CarbonMonoxideLevel_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

var CarbonMonoxidePeakLevel_Meta = Metadata[float64]{
	Typ: "91",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
}

// CarbonMonoxidePeakLevel represents a Carbon Monoxide Peak Level characteristic (91)
//
// UUID: 00000091-0000-1000-8000-0026BB765291.
func CarbonMonoxidePeakLevel(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: CarbonMonoxidePeakLevel_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

type ChargingState_Type uint8

const ChargingState_NotCharging = ChargingState_Type(0)
const ChargingState_Charging = ChargingState_Type(1)
const ChargingState_NotChargeable = ChargingState_Type(2)

var ChargingState_Meta = Metadata[uint8]{
	Typ: "8F",
}

// ChargingState represents a Charging State characteristic (8F)
//
// UUID: 0000008F-0000-1000-8000-0026BB765291.
func ChargingState(value ChargingState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: ChargingState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type ClosedCaptions_Type uint8

const ClosedCaptions_Disabled = ClosedCaptions_Type(0)
const ClosedCaptions_Enabled = ClosedCaptions_Type(1)

var ClosedCaptions_Meta = Metadata[uint8]{
	Typ: "DD",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](1),
	MinStep: 1,
}

// ClosedCaptions represents a Closed Captions characteristic (DD)
//
// UUID: 000000DD-0000-1000-8000-0026BB765291.
func ClosedCaptions(value ClosedCaptions_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: ClosedCaptions_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

var ConfiguredName_Meta = Metadata[string]{
	Typ: "E3",
}

// ConfiguredName represents a Configured Name characteristic (E3)
//
// UUID: 000000E3-0000-1000-8000-0026BB765291.
func ConfiguredName(value string, controllerWrite func(string) error) *Writable[string] {
	static := Static[string]{
		Metadata: ConfiguredName_Meta,
		value:    value,
	}
	return &Writable[string]{
		Updatable: Updatable[string]{Static: static},
		write: controllerWrite,
	}
}


// DisplayOrder represents a Display Order characteristic (136)
//
// UUID: 00000136-0000-1000-8000-0026BB765291.
func DisplayOrder(value DisplayOrderResponse, controllerWrite func(DisplayOrderRequest) (DisplayOrderResponse, error)) *WritableTLV8[DisplayOrderRequest, DisplayOrderResponse] {
	static := StaticTLV8[DisplayOrderResponse]{
		Typ:   "136",
		value: value,
	}
	return &WritableTLV8[DisplayOrderRequest, DisplayOrderResponse]{
		UpdatableTLV8: UpdatableTLV8[DisplayOrderResponse]{StaticTLV8: static},
		write: controllerWrite,
	}
}

var ColorTemperature_Meta = Metadata[uint32]{
	Typ: "CE",
	MinValue: ValuePointer[uint32](140),
	MaxValue: ValuePointer[uint32](500),
	MinStep: 1,
}

// ColorTemperature represents a Color Temperature characteristic (CE)
//
// UUID: 000000CE-0000-1000-8000-0026BB765291.
func ColorTemperature(value uint32, controllerWrite func(uint32) error) *Writable[uint32] {
	static := Static[uint32]{
		Metadata: ColorTemperature_Meta,
		value:    value,
	}
	return &Writable[uint32]{
		Updatable: Updatable[uint32]{Static: static},
		write: controllerWrite,
	}
}

type ContactSensorState_Type uint8

const ContactSensorState_ContactDetected = ContactSensorState_Type(0)
const ContactSensorState_ContactNotDetected = ContactSensorState_Type(1)

var ContactSensorState_Meta = Metadata[uint8]{
	Typ: "6A",
}

// ContactSensorState represents a Contact Sensor State characteristic (6A)
//
// UUID: 0000006A-0000-1000-8000-0026BB765291.
func ContactSensorState(value ContactSensorState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: ContactSensorState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var CoolingThresholdTemperature_Meta = Metadata[float64]{
	Typ: "D",
	Unit: "celsius",
	MinValue: ValuePointer[float64](10),
	MaxValue: ValuePointer[float64](35),
	MinStep: 0.1,
}

// CoolingThresholdTemperature represents a Cooling Threshold Temperature characteristic (D)
//
// UUID: 0000000D-0000-1000-8000-0026BB765291.
func CoolingThresholdTemperature(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: CoolingThresholdTemperature_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

type CurrentAirPurifierState_Type uint8

const CurrentAirPurifierState_Inactive = CurrentAirPurifierState_Type(0)
const CurrentAirPurifierState_Idle = CurrentAirPurifierState_Type(1)
const CurrentAirPurifierState_PurifyingAir = CurrentAirPurifierState_Type(2)

var CurrentAirPurifierState_Meta = Metadata[uint8]{
	Typ: "A9",
}

// CurrentAirPurifierState represents a Current Air Purifier State characteristic (A9)
//
// UUID: 000000A9-0000-1000-8000-0026BB765291.
func CurrentAirPurifierState(value CurrentAirPurifierState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentAirPurifierState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var CurrentAmbientLightLevel_Meta = Metadata[float64]{
	Typ: "6B",
	Unit: "lux",
	MinValue: ValuePointer[float64](0.0001),
	MaxValue: ValuePointer[float64](100000),
}

// CurrentAmbientLightLevel represents a Current Ambient Light Level characteristic (6B)
//
// UUID: 0000006B-0000-1000-8000-0026BB765291.
func CurrentAmbientLightLevel(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: CurrentAmbientLightLevel_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

type CurrentDoorState_Type uint8

const CurrentDoorState_Open = CurrentDoorState_Type(0)
const CurrentDoorState_Closed = CurrentDoorState_Type(1)
const CurrentDoorState_Opening = CurrentDoorState_Type(2)
const CurrentDoorState_Closing = CurrentDoorState_Type(3)
const CurrentDoorState_Stopped = CurrentDoorState_Type(4)

var CurrentDoorState_Meta = Metadata[uint8]{
	Typ: "E",
}

// CurrentDoorState represents a Current Door State characteristic (E)
//
// UUID: 0000000E-0000-1000-8000-0026BB765291.
func CurrentDoorState(value CurrentDoorState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentDoorState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type CurrentFanState_Type uint8

const CurrentFanState_Inactive = CurrentFanState_Type(0)
const CurrentFanState_Idle = CurrentFanState_Type(1)
const CurrentFanState_BlowingAir = CurrentFanState_Type(2)

var CurrentFanState_Meta = Metadata[uint8]{
	Typ: "AF",
}

// CurrentFanState represents a Current Fan State characteristic (AF)
//
// UUID: 000000AF-0000-1000-8000-0026BB765291.
func CurrentFanState(value CurrentFanState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentFanState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type CurrentHeaterCoolerState_Type uint8

const CurrentHeaterCoolerState_Inactive = CurrentHeaterCoolerState_Type(0)
const CurrentHeaterCoolerState_Idle = CurrentHeaterCoolerState_Type(1)
const CurrentHeaterCoolerState_Heating = CurrentHeaterCoolerState_Type(2)
const CurrentHeaterCoolerState_Cooling = CurrentHeaterCoolerState_Type(3)

var CurrentHeaterCoolerState_Meta = Metadata[uint8]{
	Typ: "B1",
}

// CurrentHeaterCoolerState represents a Current Heater Cooler State characteristic (B1)
//
// UUID: 000000B1-0000-1000-8000-0026BB765291.
func CurrentHeaterCoolerState(value CurrentHeaterCoolerState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentHeaterCoolerState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type CurrentHeatingCoolingState_Type uint8

const CurrentHeatingCoolingState_Off = CurrentHeatingCoolingState_Type(0)
const CurrentHeatingCoolingState_Heat = CurrentHeatingCoolingState_Type(1)
const CurrentHeatingCoolingState_Cool = CurrentHeatingCoolingState_Type(2)

var CurrentHeatingCoolingState_Meta = Metadata[uint8]{
	Typ: "F",
}

// CurrentHeatingCoolingState represents a Current Heating Cooling State characteristic (F)
//
// UUID: 0000000F-0000-1000-8000-0026BB765291.
func CurrentHeatingCoolingState(value CurrentHeatingCoolingState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentHeatingCoolingState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var CurrentHorizontalTiltAngle_Meta = Metadata[int32]{
	Typ: "6C",
	Unit: "arcdegrees",
	MinValue: ValuePointer[int32](-90),
	MaxValue: ValuePointer[int32](90),
	MinStep: 1,
}

// CurrentHorizontalTiltAngle represents a Current Horizontal Tilt Angle characteristic (6C)
//
// UUID: 0000006C-0000-1000-8000-0026BB765291.
func CurrentHorizontalTiltAngle(value int32) *Updatable[int32] {
	static := Static[int32]{
		Metadata: CurrentHorizontalTiltAngle_Meta,
		value:    value,
	}
	return &Updatable[int32]{
		Static: static,
	}
}

type CurrentHumidifierDehumidifierState_Type uint8

const CurrentHumidifierDehumidifierState_Inactive = CurrentHumidifierDehumidifierState_Type(0)
const CurrentHumidifierDehumidifierState_Idle = CurrentHumidifierDehumidifierState_Type(1)
const CurrentHumidifierDehumidifierState_Humidifying = CurrentHumidifierDehumidifierState_Type(2)
const CurrentHumidifierDehumidifierState_Dehumidifying = CurrentHumidifierDehumidifierState_Type(3)

var CurrentHumidifierDehumidifierState_Meta = Metadata[uint8]{
	Typ: "B3",
}

// CurrentHumidifierDehumidifierState represents a Current Humidifier Dehumidifier State characteristic (B3)
//
// UUID: 000000B3-0000-1000-8000-0026BB765291.
func CurrentHumidifierDehumidifierState(value CurrentHumidifierDehumidifierState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentHumidifierDehumidifierState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type CurrentMediaState_Type uint8

const CurrentMediaState_Play = CurrentMediaState_Type(0)
const CurrentMediaState_Pause = CurrentMediaState_Type(1)
const CurrentMediaState_Stop = CurrentMediaState_Type(2)
const CurrentMediaState_Unknown = CurrentMediaState_Type(3)

var CurrentMediaState_Meta = Metadata[uint8]{
	Typ: "E0",
	Unit: "percentage",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](3),
	MinStep: 1,
}

// CurrentMediaState represents a Current Media State characteristic (E0)
//
// UUID: 000000E0-0000-1000-8000-0026BB765291.
func CurrentMediaState(value CurrentMediaState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentMediaState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type TargetMediaState_Type uint8

const TargetMediaState_Play = TargetMediaState_Type(0)
const TargetMediaState_Pause = TargetMediaState_Type(1)
const TargetMediaState_Stop = TargetMediaState_Type(2)

var TargetMediaState_Meta = Metadata[uint8]{
	Typ: "137",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](2),
	MinStep: 1,
}

// TargetMediaState represents a Target Media State characteristic (137)
//
// UUID: 00000137-0000-1000-8000-0026BB765291.
func TargetMediaState(value TargetMediaState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetMediaState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

var CurrentPosition_Meta = Metadata[uint8]{
	Typ: "6D",
	Unit: "percentage",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](100),
	MinStep: 1,
}

// CurrentPosition represents a Current Position characteristic (6D)
//
// UUID: 0000006D-0000-1000-8000-0026BB765291.
func CurrentPosition(value uint8) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentPosition_Meta,
		value:    value,
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var CurrentRelativeHumidity_Meta = Metadata[float64]{
	Typ: "10",
	Unit: "percentage",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
	MinStep: 1,
}

// CurrentRelativeHumidity represents a Current Relative Humidity characteristic (10)
//
// UUID: 00000010-0000-1000-8000-0026BB765291.
func CurrentRelativeHumidity(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: CurrentRelativeHumidity_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

type CurrentSlatState_Type uint8

const CurrentSlatState_Fixed = CurrentSlatState_Type(0)
const CurrentSlatState_Jammed = CurrentSlatState_Type(1)
const CurrentSlatState_Swinging = CurrentSlatState_Type(2)

var CurrentSlatState_Meta = Metadata[uint8]{
	Typ: "AA",
}

// CurrentSlatState represents a Current Slat State characteristic (AA)
//
// UUID: 000000AA-0000-1000-8000-0026BB765291.
func CurrentSlatState(value CurrentSlatState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentSlatState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var CurrentTemperature_Meta = Metadata[float64]{
	Typ: "11",
	Unit: "celsius",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
	MinStep: 0.1,
}

// CurrentTemperature represents a Current Temperature characteristic (11)
//
// UUID: 00000011-0000-1000-8000-0026BB765291.
func CurrentTemperature(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: CurrentTemperature_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

var CurrentTiltAngle_Meta = Metadata[int32]{
	Typ: "C1",
	Unit: "arcdegrees",
	MinValue: ValuePointer[int32](-90),
	MaxValue: ValuePointer[int32](90),
	MinStep: 1,
}

// CurrentTiltAngle represents a Current Tilt Angle characteristic (C1)
//
// UUID: 000000C1-0000-1000-8000-0026BB765291.
func CurrentTiltAngle(value int32) *Updatable[int32] {
	static := Static[int32]{
		Metadata: CurrentTiltAngle_Meta,
		value:    value,
	}
	return &Updatable[int32]{
		Static: static,
	}
}

var CurrentVerticalTiltAngle_Meta = Metadata[int32]{
	Typ: "6E",
	Unit: "arcdegrees",
	MinValue: ValuePointer[int32](-90),
	MaxValue: ValuePointer[int32](90),
	MinStep: 1,
}

// CurrentVerticalTiltAngle represents a Current Vertical Tilt Angle characteristic (6E)
//
// UUID: 0000006E-0000-1000-8000-0026BB765291.
func CurrentVerticalTiltAngle(value int32) *Updatable[int32] {
	static := Static[int32]{
		Metadata: CurrentVerticalTiltAngle_Meta,
		value:    value,
	}
	return &Updatable[int32]{
		Static: static,
	}
}

var DigitalZoom_Meta = Metadata[float64]{
	Typ: "11D",
}

// DigitalZoom represents a Digital Zoom characteristic (11D)
//
// UUID: 0000011D-0000-1000-8000-0026BB765291.
func DigitalZoom(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: DigitalZoom_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

type FilterChangeIndication_Type uint8

const FilterChangeIndication_FilterOK = FilterChangeIndication_Type(0)
const FilterChangeIndication_ChangeFilter = FilterChangeIndication_Type(1)

var FilterChangeIndication_Meta = Metadata[uint8]{
	Typ: "AC",
}

// FilterChangeIndication represents a Filter Change Indication characteristic (AC)
//
// UUID: 000000AC-0000-1000-8000-0026BB765291.
func FilterChangeIndication(value FilterChangeIndication_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: FilterChangeIndication_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var FilterLifeLevel_Meta = Metadata[float64]{
	Typ: "AB",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
	MinStep: 1,
}

// FilterLifeLevel represents a Filter Life Level characteristic (AB)
//
// UUID: 000000AB-0000-1000-8000-0026BB765291.
func FilterLifeLevel(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: FilterLifeLevel_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

var FirmwareRevision_Meta = Metadata[string]{
	Typ: "52",
}

// FirmwareRevision represents a Firmware Revision characteristic (52)
//
// UUID: 00000052-0000-1000-8000-0026BB765291.
func FirmwareRevision(value string) Static[string] {
	static := Static[string]{
		Metadata: FirmwareRevision_Meta,
		value:    value,
	}
	return static
}

var HardwareRevision_Meta = Metadata[string]{
	Typ: "53",
}

// HardwareRevision represents a Hardware Revision characteristic (53)
//
// UUID: 00000053-0000-1000-8000-0026BB765291.
func HardwareRevision(value string) Static[string] {
	static := Static[string]{
		Metadata: HardwareRevision_Meta,
		value:    value,
	}
	return static
}

var HeatingThresholdTemperature_Meta = Metadata[float64]{
	Typ: "12",
	Unit: "celsius",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](25),
	MinStep: 0.1,
}

// HeatingThresholdTemperature represents a Heating Threshold Temperature characteristic (12)
//
// UUID: 00000012-0000-1000-8000-0026BB765291.
func HeatingThresholdTemperature(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: HeatingThresholdTemperature_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

var HoldPosition_Meta = Metadata[bool]{
	Typ: "6F",
}

// HoldPosition represents a Hold Position characteristic (6F)
//
// UUID: 0000006F-0000-1000-8000-0026BB765291.
func HoldPosition(controllerWrite func(bool) error) WriteOnly[bool] {
	return WriteOnly[bool]{
		Metadata: HoldPosition_Meta,
		write:    controllerWrite,
	}
}

var Hue_Meta = Metadata[float64]{
	Typ: "13",
	Unit: "arcdegrees",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](360),
	MinStep: 1,
}

// Hue represents a Hue characteristic (13)
//
// UUID: 00000013-0000-1000-8000-0026BB765291.
func Hue(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: Hue_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

var Identify_Meta = Metadata[bool]{
	Typ: "14",
}

// Identify represents a Identify characteristic (14)
//
// UUID: 00000014-0000-1000-8000-0026BB765291.
func Identify(controllerWrite func(bool) error) WriteOnly[bool] {
	return WriteOnly[bool]{
		Metadata: Identify_Meta,
		write:    controllerWrite,
	}
}

type InputSourceType_Type uint8

const InputSourceType_Other = InputSourceType_Type(0)
const InputSourceType_HomeScreen = InputSourceType_Type(1)
const InputSourceType_Application = InputSourceType_Type(10)
const InputSourceType_Tuner = InputSourceType_Type(2)
const InputSourceType_Hdmi = InputSourceType_Type(3)
const InputSourceType_CompositeVideo = InputSourceType_Type(4)
const InputSourceType_SVideo = InputSourceType_Type(5)
const InputSourceType_ComponentVideo = InputSourceType_Type(6)
const InputSourceType_Dvi = InputSourceType_Type(7)
const InputSourceType_Airplay = InputSourceType_Type(8)
const InputSourceType_Usb = InputSourceType_Type(9)

var InputSourceType_Meta = Metadata[uint8]{
	Typ: "DB",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](10),
	MinStep: 1,
}

// InputSourceType represents a Input Source Type characteristic (DB)
//
// UUID: 000000DB-0000-1000-8000-0026BB765291.
func InputSourceType(value InputSourceType_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: InputSourceType_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type InputDeviceType_Type uint8

const InputDeviceType_Other = InputDeviceType_Type(0)
const InputDeviceType_Tv = InputDeviceType_Type(1)
const InputDeviceType_Recording = InputDeviceType_Type(2)
const InputDeviceType_Tuner = InputDeviceType_Type(3)
const InputDeviceType_Playback = InputDeviceType_Type(4)
const InputDeviceType_AudioSystem = InputDeviceType_Type(5)

var InputDeviceType_Meta = Metadata[uint8]{
	Typ: "DC",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](5),
	MinStep: 1,
}

// InputDeviceType represents a Input Device Type characteristic (DC)
//
// UUID: 000000DC-0000-1000-8000-0026BB765291.
func InputDeviceType(value InputDeviceType_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: InputDeviceType_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var Identifier_Meta = Metadata[uint32]{
	Typ: "E6",
	MinValue: ValuePointer[uint32](0),
	MinStep: 1,
}

// Identifier represents a Identifier characteristic (E6)
//
// UUID: 000000E6-0000-1000-8000-0026BB765291.
func Identifier(value uint32) Static[uint32] {
	static := Static[uint32]{
		Metadata: Identifier_Meta,
		value:    value,
	}
	return static
}

type CurrentVisibilityState_Type uint8

const CurrentVisibilityState_Shown = CurrentVisibilityState_Type(0)
const CurrentVisibilityState_Hidden = CurrentVisibilityState_Type(1)

var CurrentVisibilityState_Meta = Metadata[uint8]{
	Typ: "135",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](3),
	MinStep: 1,
}

// CurrentVisibilityState represents a Current Visibility State characteristic (135)
//
// UUID: 00000135-0000-1000-8000-0026BB765291.
func CurrentVisibilityState(value CurrentVisibilityState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: CurrentVisibilityState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type TargetVisibilityState_Type uint8

const TargetVisibilityState_Shown = TargetVisibilityState_Type(0)
const TargetVisibilityState_Hidden = TargetVisibilityState_Type(1)

var TargetVisibilityState_Meta = Metadata[uint8]{
	Typ: "134",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](2),
	MinStep: 1,
}

// TargetVisibilityState represents a Target Visibility State characteristic (134)
//
// UUID: 00000134-0000-1000-8000-0026BB765291.
func TargetVisibilityState(value TargetVisibilityState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetVisibilityState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

var ImageMirroring_Meta = Metadata[bool]{
	Typ: "11F",
}

// ImageMirroring represents a Image Mirroring characteristic (11F)
//
// UUID: 0000011F-0000-1000-8000-0026BB765291.
func ImageMirroring(value bool, controllerWrite func(bool) error) *Writable[bool] {
	static := Static[bool]{
		Metadata: ImageMirroring_Meta,
		value:    value,
	}
	return &Writable[bool]{
		Updatable: Updatable[bool]{Static: static},
		write: controllerWrite,
	}
}

var ImageRotation_Meta = Metadata[float64]{
	Typ: "11E",
	Unit: "arcdegrees",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](270),
	MinStep: 90,
}

// ImageRotation represents a Image Rotation characteristic (11E)
//
// UUID: 0000011E-0000-1000-8000-0026BB765291.
func ImageRotation(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: ImageRotation_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

type InUse_Type uint8

const InUse_NotInUse = InUse_Type(0)
const InUse_InUse = InUse_Type(1)

var InUse_Meta = Metadata[uint8]{
	Typ: "D2",
}

// InUse represents a In Use characteristic (D2)
//
// UUID: 000000D2-0000-1000-8000-0026BB765291.
func InUse(value InUse_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: InUse_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type IsConfigured_Type uint8

const IsConfigured_NotConfigured = IsConfigured_Type(0)
const IsConfigured_Configured = IsConfigured_Type(1)

var IsConfigured_Meta = Metadata[uint8]{
	Typ: "D6",
}

// IsConfigured represents a Is Configured characteristic (D6)
//
// UUID: 000000D6-0000-1000-8000-0026BB765291.
func IsConfigured(value IsConfigured_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: IsConfigured_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type LeakDetected_Type uint8

const LeakDetected_LeakNotDetected = LeakDetected_Type(0)
const LeakDetected_LeakDetected = LeakDetected_Type(1)

var LeakDetected_Meta = Metadata[uint8]{
	Typ: "70",
}

// LeakDetected represents a Leak Detected characteristic (70)
//
// UUID: 00000070-0000-1000-8000-0026BB765291.
func LeakDetected(value LeakDetected_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: LeakDetected_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}


// LockControlPoint represents a Lock Control Point characteristic (19)
//
// UUID: 00000019-0000-1000-8000-0026BB765291.
func LockControlPoint(controllerWrite func(LockControlPointRequest) error) WriteOnlyTLV8[LockControlPointRequest] {
	return WriteOnlyTLV8[LockControlPointRequest]{
		StaticTLV8: StaticTLV8[struct{}]{Typ: "19"},
		write: controllerWrite,
	}
}

type LockCurrentState_Type uint8

const LockCurrentState_Unsecured = LockCurrentState_Type(0)
const LockCurrentState_Secured = LockCurrentState_Type(1)
const LockCurrentState_Jammed = LockCurrentState_Type(2)
const LockCurrentState_Unknown = LockCurrentState_Type(3)

var LockCurrentState_Meta = Metadata[uint8]{
	Typ: "1D",
}

// LockCurrentState represents a Lock Current State characteristic (1D)
//
// UUID: 0000001D-0000-1000-8000-0026BB765291.
func LockCurrentState(value LockCurrentState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: LockCurrentState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type LockLastKnownAction_Type uint8

const LockLastKnownAction_SecuredPhysicallyInterior = LockLastKnownAction_Type(0)
const LockLastKnownAction_UnsecuredPhysicallyInterior = LockLastKnownAction_Type(1)
const LockLastKnownAction_SecuredPhysicallyExterior = LockLastKnownAction_Type(2)
const LockLastKnownAction_UnsecuredPhysicallyExterior = LockLastKnownAction_Type(3)
const LockLastKnownAction_SecuredByKeypad = LockLastKnownAction_Type(4)
const LockLastKnownAction_UnsecuredByKeypad = LockLastKnownAction_Type(5)
const LockLastKnownAction_SecuredRemotely = LockLastKnownAction_Type(6)
const LockLastKnownAction_UnsecuredRemotely = LockLastKnownAction_Type(7)
const LockLastKnownAction_SecuredByAutoSecureTimeout = LockLastKnownAction_Type(8)

var LockLastKnownAction_Meta = Metadata[uint8]{
	Typ: "1C",
}

// LockLastKnownAction represents a Lock Last Known Action characteristic (1C)
//
// UUID: 0000001C-0000-1000-8000-0026BB765291.
func LockLastKnownAction(value LockLastKnownAction_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: LockLastKnownAction_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var LockManagementAutoSecurityTimeout_Meta = Metadata[uint32]{
	Typ: "1A",
	Unit: "seconds",
}

// LockManagementAutoSecurityTimeout represents a Lock Management Auto Security Timeout characteristic (1A)
//
// UUID: 0000001A-0000-1000-8000-0026BB765291.
func LockManagementAutoSecurityTimeout(value uint32, controllerWrite func(uint32) error) *Writable[uint32] {
	static := Static[uint32]{
		Metadata: LockManagementAutoSecurityTimeout_Meta,
		value:    value,
	}
	return &Writable[uint32]{
		Updatable: Updatable[uint32]{Static: static},
		write: controllerWrite,
	}
}

type LockPhysicalControls_Type uint8

const LockPhysicalControls_ControlLockDisabled = LockPhysicalControls_Type(0)
const LockPhysicalControls_ControlLockEnabled = LockPhysicalControls_Type(1)

var LockPhysicalControls_Meta = Metadata[uint8]{
	Typ: "A7",
}

// LockPhysicalControls represents a Lock Physical Controls characteristic (A7)
//
// UUID: 000000A7-0000-1000-8000-0026BB765291.
func LockPhysicalControls(value LockPhysicalControls_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: LockPhysicalControls_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type LockTargetState_Type uint8

const LockTargetState_Unsecured = LockTargetState_Type(0)
const LockTargetState_Secured = LockTargetState_Type(1)

var LockTargetState_Meta = Metadata[uint8]{
	Typ: "1E",
}

// LockTargetState represents a Lock Target State characteristic (1E)
//
// UUID: 0000001E-0000-1000-8000-0026BB765291.
func LockTargetState(value LockTargetState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: LockTargetState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}


// Logs represents a Logs characteristic (1F)
//
// UUID: 0000001F-0000-1000-8000-0026BB765291.
func Logs(value LogsResponse) *UpdatableTLV8[LogsResponse] {
	static := StaticTLV8[LogsResponse]{
		Typ:   "1F",
		value: value,
	}
	return &UpdatableTLV8[LogsResponse]{
		StaticTLV8: static,
	}
}

var Manufacturer_Meta = Metadata[string]{
	Typ: "20",
}

// Manufacturer represents a Manufacturer characteristic (20)
//
// UUID: 00000020-0000-1000-8000-0026BB765291.
func Manufacturer(value string) Static[string] {
	static := Static[string]{
		Metadata: Manufacturer_Meta,
		value:    value,
	}
	return static
}

var Model_Meta = Metadata[string]{
	Typ: "21",
}

// Model represents a Model characteristic (21)
//
// UUID: 00000021-0000-1000-8000-0026BB765291.
func Model(value string) Static[string] {
	static := Static[string]{
		Metadata: Model_Meta,
		value:    value,
	}
	return static
}

var MotionDetected_Meta = Metadata[bool]{
	Typ: "22",
}

// MotionDetected represents a Motion Detected characteristic (22)
//
// UUID: 00000022-0000-1000-8000-0026BB765291.
func MotionDetected(value bool) *Updatable[bool] {
	static := Static[bool]{
		Metadata: MotionDetected_Meta,
		value:    value,
	}
	return &Updatable[bool]{
		Static: static,
	}
}

var Mute_Meta = Metadata[bool]{
	Typ: "11A",
}

// Mute represents a Mute characteristic (11A)
//
// UUID: 0000011A-0000-1000-8000-0026BB765291.
func Mute(value bool, controllerWrite func(bool) error) *Writable[bool] {
	static := Static[bool]{
		Metadata: Mute_Meta,
		value:    value,
	}
	return &Writable[bool]{
		Updatable: Updatable[bool]{Static: static},
		write: controllerWrite,
	}
}

var Name_Meta = Metadata[string]{
	Typ: "23",
}

// Name represents a Name characteristic (23)
//
// UUID: 00000023-0000-1000-8000-0026BB765291.
func Name(value string) Static[string] {
	static := Static[string]{
		Metadata: Name_Meta,
		value:    value,
	}
	return static
}

var NightVision_Meta = Metadata[bool]{
	Typ: "11B",
}

// NightVision represents a Night Vision characteristic (11B)
//
// UUID: 0000011B-0000-1000-8000-0026BB765291.
func NightVision(value bool, controllerWrite func(bool) error) *Writable[bool] {
	static := Static[bool]{
		Metadata: NightVision_Meta,
		value:    value,
	}
	return &Writable[bool]{
		Updatable: Updatable[bool]{Static: static},
		write: controllerWrite,
	}
}

var NitrogenDioxideDensity_Meta = Metadata[float64]{
	Typ: "C4",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](1000),
	MinStep: 1,
}

// NitrogenDioxideDensity represents a Nitrogen Dioxide Density characteristic (C4)
//
// UUID: 000000C4-0000-1000-8000-0026BB765291.
func NitrogenDioxideDensity(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: NitrogenDioxideDensity_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

var ObstructionDetected_Meta = Metadata[bool]{
	Typ: "24",
}

// ObstructionDetected represents a Obstruction Detected characteristic (24)
//
// UUID: 00000024-0000-1000-8000-0026BB765291.
func ObstructionDetected(value bool) *Updatable[bool] {
	static := Static[bool]{
		Metadata: ObstructionDetected_Meta,
		value:    value,
	}
	return &Updatable[bool]{
		Static: static,
	}
}

type OccupancyDetected_Type uint8

const OccupancyDetected_OccupancyNotDetected = OccupancyDetected_Type(0)
const OccupancyDetected_OccupancyDetected = OccupancyDetected_Type(1)

var OccupancyDetected_Meta = Metadata[uint8]{
	Typ: "71",
}

// OccupancyDetected represents a Occupancy Detected characteristic (71)
//
// UUID: 00000071-0000-1000-8000-0026BB765291.
func OccupancyDetected(value OccupancyDetected_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: OccupancyDetected_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var On_Meta = Metadata[bool]{
	Typ: "25",
}

// On represents a On characteristic (25)
//
// UUID: 00000025-0000-1000-8000-0026BB765291.
func On(value bool, controllerWrite func(bool) error) *Writable[bool] {
	static := Static[bool]{
		Metadata: On_Meta,
		value:    value,
	}
	return &Writable[bool]{
		Updatable: Updatable[bool]{Static: static},
		write: controllerWrite,
	}
}

var OpticalZoom_Meta = Metadata[float64]{
	Typ: "11C",
}

// OpticalZoom represents a Optical Zoom characteristic (11C)
//
// UUID: 0000011C-0000-1000-8000-0026BB765291.
func OpticalZoom(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: OpticalZoom_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

var OutletInUse_Meta = Metadata[bool]{
	Typ: "26",
}

// OutletInUse represents a Outlet In Use characteristic (26)
//
// UUID: 00000026-0000-1000-8000-0026BB765291.
func OutletInUse(value bool) *Updatable[bool] {
	static := Static[bool]{
		Metadata: OutletInUse_Meta,
		value:    value,
	}
	return &Updatable[bool]{
		Static: static,
	}
}

var OzoneDensity_Meta = Metadata[float64]{
	Typ: "C3",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](1000),
	MinStep: 1,
}

// OzoneDensity represents a Ozone Density characteristic (C3)
//
// UUID: 000000C3-0000-1000-8000-0026BB765291.
func OzoneDensity(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: OzoneDensity_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}


// PairSetup represents a Pair Setup characteristic (4C)
//
// UUID: 0000004C-0000-1000-8000-0026BB765291.
func PairSetup(value PairSetupResponse, controllerWrite func(PairSetupRequest) (PairSetupResponse, error)) *WritableTLV8[PairSetupRequest, PairSetupResponse] {
	static := StaticTLV8[PairSetupResponse]{
		Typ:   "4C",
		value: value,
	}
	return &WritableTLV8[PairSetupRequest, PairSetupResponse]{
		UpdatableTLV8: UpdatableTLV8[PairSetupResponse]{StaticTLV8: static},
		write: controllerWrite,
	}
}


// PairVerify represents a Pair Verify characteristic (4E)
//
// UUID: 0000004E-0000-1000-8000-0026BB765291.
func PairVerify(value PairVerifyResponse, controllerWrite func(PairVerifyRequest) (PairVerifyResponse, error)) *WritableTLV8[PairVerifyRequest, PairVerifyResponse] {
	static := StaticTLV8[PairVerifyResponse]{
		Typ:   "4E",
		value: value,
	}
	return &WritableTLV8[PairVerifyRequest, PairVerifyResponse]{
		UpdatableTLV8: UpdatableTLV8[PairVerifyResponse]{StaticTLV8: static},
		write: controllerWrite,
	}
}

var PairingFeatures_Meta = Metadata[uint8]{
	Typ: "4F",
}

// PairingFeatures represents a Pairing Features characteristic (4F)
//
// UUID: 0000004F-0000-1000-8000-0026BB765291.
func PairingFeatures(value uint8) Static[uint8] {
	static := Static[uint8]{
		Metadata: PairingFeatures_Meta,
		value:    value,
	}
	return static
}


// PairingPairings represents a Pairing Pairings characteristic (50)
//
// UUID: 00000050-0000-1000-8000-0026BB765291.
func PairingPairings(value PairingPairingsResponse, controllerWrite func(PairingPairingsRequest) (PairingPairingsResponse, error)) *WritableTLV8[PairingPairingsRequest, PairingPairingsResponse] {
	static := StaticTLV8[PairingPairingsResponse]{
		Typ:   "50",
		value: value,
	}
	return &WritableTLV8[PairingPairingsRequest, PairingPairingsResponse]{
		UpdatableTLV8: UpdatableTLV8[PairingPairingsResponse]{StaticTLV8: static},
		write: controllerWrite,
	}
}

var PM10Density_Meta = Metadata[float64]{
	Typ: "C7",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](1000),
	MinStep: 1,
}

// PM10Density represents a PM10 Density characteristic (C7)
//
// UUID: 000000C7-0000-1000-8000-0026BB765291.
func PM10Density(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: PM10Density_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

var PM25Density_Meta = Metadata[float64]{
	Typ: "C6",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](1000),
	MinStep: 1,
}

// PM25Density represents a PM2.5 Density characteristic (C6)
//
// UUID: 000000C6-0000-1000-8000-0026BB765291.
func PM25Density(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: PM25Density_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

type PositionState_Type uint8

const PositionState_Decreasing = PositionState_Type(0)
const PositionState_Increasing = PositionState_Type(1)
const PositionState_Stopped = PositionState_Type(2)

var PositionState_Meta = Metadata[uint8]{
	Typ: "72",
}

// PositionState represents a Position State characteristic (72)
//
// UUID: 00000072-0000-1000-8000-0026BB765291.
func PositionState(value PositionState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: PositionState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type PictureMode_Type uint16

const PictureMode_Other = PictureMode_Type(0)
const PictureMode_Standard = PictureMode_Type(1)
const PictureMode_Calibrated = PictureMode_Type(2)
const PictureMode_CalibratedDark = PictureMode_Type(3)
const PictureMode_Vivid = PictureMode_Type(4)
const PictureMode_Game = PictureMode_Type(5)
const PictureMode_Computer = PictureMode_Type(6)
const PictureMode_Custom = PictureMode_Type(7)

var PictureMode_Meta = Metadata[uint16]{
	Typ: "E2",
	MinValue: ValuePointer[uint16](0),
	MaxValue: ValuePointer[uint16](13),
	MinStep: 1,
}

// PictureMode represents a Picture Mode characteristic (E2)
//
// UUID: 000000E2-0000-1000-8000-0026BB765291.
func PictureMode(value PictureMode_Type, controllerWrite func(uint16) error) *Writable[uint16] {
	static := Static[uint16]{
		Metadata: PictureMode_Meta,
		value:    uint16(value),
	}
	return &Writable[uint16]{
		Updatable: Updatable[uint16]{Static: static},
		write: controllerWrite,
	}
}

type PowerModeSelection_Type uint8

const PowerModeSelection_Show = PowerModeSelection_Type(0)
const PowerModeSelection_Hide = PowerModeSelection_Type(1)

var PowerModeSelection_Meta = Metadata[uint8]{
	Typ: "DF",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](1),
	MinStep: 1,
}

// PowerModeSelection represents a Power Mode Selection characteristic (DF)
//
// UUID: 000000DF-0000-1000-8000-0026BB765291.
func PowerModeSelection(controllerWrite func(uint8) error) WriteOnly[uint8] {
	return WriteOnly[uint8]{
		Metadata: PowerModeSelection_Meta,
		write:    controllerWrite,
	}
}

type ProgramMode_Type uint8

const ProgramMode_NoProgramScheduled = ProgramMode_Type(0)
const ProgramMode_ProgramScheduled = ProgramMode_Type(1)
const ProgramMode_ProgramScheduledManualMode = ProgramMode_Type(2)

var ProgramMode_Meta = Metadata[uint8]{
	Typ: "D1",
}

// ProgramMode represents a Program Mode characteristic (D1)
//
// UUID: 000000D1-0000-1000-8000-0026BB765291.
func ProgramMode(value ProgramMode_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: ProgramMode_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type ProgrammableSwitchEvent_Type uint8

const ProgrammableSwitchEvent_SinglePress = ProgrammableSwitchEvent_Type(0)
const ProgrammableSwitchEvent_DoublePress = ProgrammableSwitchEvent_Type(1)
const ProgrammableSwitchEvent_LongPress = ProgrammableSwitchEvent_Type(2)

var ProgrammableSwitchEvent_Meta = Metadata[uint8]{
	Typ: "73",
}

// ProgrammableSwitchEvent represents a Programmable Switch Event characteristic (73)
//
// UUID: 00000073-0000-1000-8000-0026BB765291.
func ProgrammableSwitchEvent(value ProgrammableSwitchEvent_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: ProgrammableSwitchEvent_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type RemoteKey_Type uint8

const RemoteKey_Rewind = RemoteKey_Type(0)
const RemoteKey_FastForward = RemoteKey_Type(1)
const RemoteKey_Exit = RemoteKey_Type(10)
const RemoteKey_PlayPause = RemoteKey_Type(11)
const RemoteKey_Info = RemoteKey_Type(15)
const RemoteKey_NextTrack = RemoteKey_Type(2)
const RemoteKey_PrevTrack = RemoteKey_Type(3)
const RemoteKey_ArrowUp = RemoteKey_Type(4)
const RemoteKey_ArrowDown = RemoteKey_Type(5)
const RemoteKey_ArrowLeft = RemoteKey_Type(6)
const RemoteKey_ArrowRight = RemoteKey_Type(7)
const RemoteKey_Select = RemoteKey_Type(8)
const RemoteKey_Back = RemoteKey_Type(9)

var RemoteKey_Meta = Metadata[uint8]{
	Typ: "E1",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](16),
	MinStep: 1,
}

// RemoteKey represents a Remote Key characteristic (E1)
//
// UUID: 000000E1-0000-1000-8000-0026BB765291.
func RemoteKey(controllerWrite func(uint8) error) WriteOnly[uint8] {
	return WriteOnly[uint8]{
		Metadata: RemoteKey_Meta,
		write:    controllerWrite,
	}
}

var RelativeHumidityDehumidifierThreshold_Meta = Metadata[float64]{
	Typ: "C9",
	Unit: "percentage",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
	MinStep: 1,
}

// RelativeHumidityDehumidifierThreshold represents a Relative Humidity Dehumidifier Threshold characteristic (C9)
//
// UUID: 000000C9-0000-1000-8000-0026BB765291.
func RelativeHumidityDehumidifierThreshold(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: RelativeHumidityDehumidifierThreshold_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

var RelativeHumidityHumidifierThreshold_Meta = Metadata[float64]{
	Typ: "CA",
	Unit: "percentage",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
	MinStep: 1,
}

// RelativeHumidityHumidifierThreshold represents a Relative Humidity Humidifier Threshold characteristic (CA)
//
// UUID: 000000CA-0000-1000-8000-0026BB765291.
func RelativeHumidityHumidifierThreshold(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: RelativeHumidityHumidifierThreshold_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

var RemainingDuration_Meta = Metadata[uint32]{
	Typ: "D4",
	MinValue: ValuePointer[uint32](0),
	MaxValue: ValuePointer[uint32](3600),
	MinStep: 1,
}

// RemainingDuration represents a Remaining Duration characteristic (D4)
//
// UUID: 000000D4-0000-1000-8000-0026BB765291.
func RemainingDuration(value uint32) *Updatable[uint32] {
	static := Static[uint32]{
		Metadata: RemainingDuration_Meta,
		value:    value,
	}
	return &Updatable[uint32]{
		Static: static,
	}
}

var ResetFilterIndication_Meta = Metadata[uint8]{
	Typ: "AD",
	MinValue: ValuePointer[uint8](1),
	MaxValue: ValuePointer[uint8](1),
	MinStep: 1,
}

// ResetFilterIndication represents a Reset Filter Indication characteristic (AD)
//
// UUID: 000000AD-0000-1000-8000-0026BB765291.
func ResetFilterIndication(controllerWrite func(uint8) error) WriteOnly[uint8] {
	return WriteOnly[uint8]{
		Metadata: ResetFilterIndication_Meta,
		write:    controllerWrite,
	}
}

type RotationDirection_Type int32

const RotationDirection_Clockwise = RotationDirection_Type(0)
const RotationDirection_Counterclockwise = RotationDirection_Type(1)

var RotationDirection_Meta = Metadata[int32]{
	Typ: "28",
}

// RotationDirection represents a Rotation Direction characteristic (28)
//
// UUID: 00000028-0000-1000-8000-0026BB765291.
func RotationDirection(value RotationDirection_Type, controllerWrite func(int32) error) *Writable[int32] {
	static := Static[int32]{
		Metadata: RotationDirection_Meta,
		value:    int32(value),
	}
	return &Writable[int32]{
		Updatable: Updatable[int32]{Static: static},
		write: controllerWrite,
	}
}

var RotationSpeed_Meta = Metadata[float64]{
	Typ: "29",
	Unit: "percentage",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
	MinStep: 1,
}

// RotationSpeed represents a Rotation Speed characteristic (29)
//
// UUID: 00000029-0000-1000-8000-0026BB765291.
func RotationSpeed(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: RotationSpeed_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

var Saturation_Meta = Metadata[float64]{
	Typ: "2F",
	Unit: "percentage",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
	MinStep: 1,
}

// Saturation represents a Saturation characteristic (2F)
//
// UUID: 0000002F-0000-1000-8000-0026BB765291.
func Saturation(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: Saturation_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

var SecuritySystemAlarmType_Meta = Metadata[uint8]{
	Typ: "8E",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](1),
	MinStep: 1,
}

// SecuritySystemAlarmType represents a Security System Alarm Type characteristic (8E)
//
// UUID: 0000008E-0000-1000-8000-0026BB765291.
func SecuritySystemAlarmType(value uint8) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: SecuritySystemAlarmType_Meta,
		value:    value,
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type SecuritySystemCurrentState_Type uint8

const SecuritySystemCurrentState_StayArm = SecuritySystemCurrentState_Type(0)
const SecuritySystemCurrentState_AwayArm = SecuritySystemCurrentState_Type(1)
const SecuritySystemCurrentState_NightArm = SecuritySystemCurrentState_Type(2)
const SecuritySystemCurrentState_Disarmed = SecuritySystemCurrentState_Type(3)
const SecuritySystemCurrentState_AlarmTriggered = SecuritySystemCurrentState_Type(4)

var SecuritySystemCurrentState_Meta = Metadata[uint8]{
	Typ: "66",
}

// SecuritySystemCurrentState represents a Security System Current State characteristic (66)
//
// UUID: 00000066-0000-1000-8000-0026BB765291.
func SecuritySystemCurrentState(value SecuritySystemCurrentState_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: SecuritySystemCurrentState_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type SecuritySystemTargetState_Type uint8

const SecuritySystemTargetState_StayArm = SecuritySystemTargetState_Type(0)
const SecuritySystemTargetState_AwayArm = SecuritySystemTargetState_Type(1)
const SecuritySystemTargetState_NightArm = SecuritySystemTargetState_Type(2)
const SecuritySystemTargetState_Disarm = SecuritySystemTargetState_Type(3)

var SecuritySystemTargetState_Meta = Metadata[uint8]{
	Typ: "67",
}

// SecuritySystemTargetState represents a Security System Target State characteristic (67)
//
// UUID: 00000067-0000-1000-8000-0026BB765291.
func SecuritySystemTargetState(value SecuritySystemTargetState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: SecuritySystemTargetState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}


// SelectedRTPStreamConfiguration represents a Selected RTP Stream Configuration characteristic (117)
//
// UUID: 00000117-0000-1000-8000-0026BB765291.
func SelectedRTPStreamConfiguration(value SelectedRTPStreamConfigurationResponse, controllerWrite func(SelectedRTPStreamConfigurationRequest) (SelectedRTPStreamConfigurationResponse, error)) *WritableTLV8[SelectedRTPStreamConfigurationRequest, SelectedRTPStreamConfigurationResponse] {
	static := StaticTLV8[SelectedRTPStreamConfigurationResponse]{
		Typ:   "117",
		value: value,
	}
	return &WritableTLV8[SelectedRTPStreamConfigurationRequest, SelectedRTPStreamConfigurationResponse]{
		UpdatableTLV8: UpdatableTLV8[SelectedRTPStreamConfigurationResponse]{StaticTLV8: static},
		write: controllerWrite,
	}
}

var SerialNumber_Meta = Metadata[string]{
	Typ: "30",
}

// SerialNumber represents a Serial Number characteristic (30)
//
// UUID: 00000030-0000-1000-8000-0026BB765291.
func SerialNumber(value string) Static[string] {
	static := Static[string]{
		Metadata: SerialNumber_Meta,
		value:    value,
	}
	return static
}

var ServiceLabelIndex_Meta = Metadata[uint8]{
	Typ: "CB",
	MinValue: ValuePointer[uint8](1),
	MaxValue: ValuePointer[uint8](255),
	MinStep: 1,
}

// ServiceLabelIndex represents a Service Label Index characteristic (CB)
//
// UUID: 000000CB-0000-1000-8000-0026BB765291.
func ServiceLabelIndex(value uint8) Static[uint8] {
	static := Static[uint8]{
		Metadata: ServiceLabelIndex_Meta,
		value:    value,
	}
	return static
}

type ServiceLabelNamespace_Type uint8

const ServiceLabelNamespace_Dots = ServiceLabelNamespace_Type(0)
const ServiceLabelNamespace_ArabicNumerals = ServiceLabelNamespace_Type(1)

var ServiceLabelNamespace_Meta = Metadata[uint8]{
	Typ: "CD",
}

// ServiceLabelNamespace represents a Service Label Namespace characteristic (CD)
//
// UUID: 000000CD-0000-1000-8000-0026BB765291.
func ServiceLabelNamespace(value ServiceLabelNamespace_Type) Static[uint8] {
	static := Static[uint8]{
		Metadata: ServiceLabelNamespace_Meta,
		value:    uint8(value),
	}
	return static
}

var SetDuration_Meta = Metadata[uint32]{
	Typ: "D3",
	MinValue: ValuePointer[uint32](0),
	MaxValue: ValuePointer[uint32](3600),
	MinStep: 1,
}

// SetDuration represents a Set Duration characteristic (D3)
//
// UUID: 000000D3-0000-1000-8000-0026BB765291.
func SetDuration(value uint32, controllerWrite func(uint32) error) *Writable[uint32] {
	static := Static[uint32]{
		Metadata: SetDuration_Meta,
		value:    value,
	}
	return &Writable[uint32]{
		Updatable: Updatable[uint32]{Static: static},
		write: controllerWrite,
	}
}


// SetupEndpoints represents a Setup Endpoints characteristic (118)
//
// UUID: 00000118-0000-1000-8000-0026BB765291.
func SetupEndpoints(value SetupEndpointsResponse, controllerWrite func(SetupEndpointsRequest) (SetupEndpointsResponse, error)) *WritableTLV8[SetupEndpointsRequest, SetupEndpointsResponse] {
	static := StaticTLV8[SetupEndpointsResponse]{
		Typ:   "118",
		value: value,
	}
	return &WritableTLV8[SetupEndpointsRequest, SetupEndpointsResponse]{
		UpdatableTLV8: UpdatableTLV8[SetupEndpointsResponse]{StaticTLV8: static},
		write: controllerWrite,
	}
}

type SlatType_Type uint8

const SlatType_Horizontal = SlatType_Type(0)
const SlatType_Vertical = SlatType_Type(1)

var SlatType_Meta = Metadata[uint8]{
	Typ: "C0",
}

// SlatType represents a Slat Type characteristic (C0)
//
// UUID: 000000C0-0000-1000-8000-0026BB765291.
func SlatType(value SlatType_Type) Static[uint8] {
	static := Static[uint8]{
		Metadata: SlatType_Meta,
		value:    uint8(value),
	}
	return static
}

type SleepDiscoveryMode_Type uint8

const SleepDiscoveryMode_NotDiscoverable = SleepDiscoveryMode_Type(0)
const SleepDiscoveryMode_AlwaysDiscoverable = SleepDiscoveryMode_Type(1)

var SleepDiscoveryMode_Meta = Metadata[uint8]{
	Typ: "E8",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](1),
}

// SleepDiscoveryMode represents a Sleep Discovery Mode characteristic (E8)
//
// UUID: 000000E8-0000-1000-8000-0026BB765291.
func SleepDiscoveryMode(value SleepDiscoveryMode_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: SleepDiscoveryMode_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type SmokeDetected_Type uint8

const SmokeDetected_SmokeNotDetected = SmokeDetected_Type(0)
const SmokeDetected_SmokeDetected = SmokeDetected_Type(1)

var SmokeDetected_Meta = Metadata[uint8]{
	Typ: "76",
}

// SmokeDetected represents a Smoke Detected characteristic (76)
//
// UUID: 00000076-0000-1000-8000-0026BB765291.
func SmokeDetected(value SmokeDetected_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: SmokeDetected_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var StatusActive_Meta = Metadata[bool]{
	Typ: "75",
}

// StatusActive represents a Status Active characteristic (75)
//
// UUID: 00000075-0000-1000-8000-0026BB765291.
func StatusActive(value bool) *Updatable[bool] {
	static := Static[bool]{
		Metadata: StatusActive_Meta,
		value:    value,
	}
	return &Updatable[bool]{
		Static: static,
	}
}

type StatusFault_Type uint8

const StatusFault_NoFault = StatusFault_Type(0)
const StatusFault_GeneralFault = StatusFault_Type(1)

var StatusFault_Meta = Metadata[uint8]{
	Typ: "77",
}

// StatusFault represents a Status Fault characteristic (77)
//
// UUID: 00000077-0000-1000-8000-0026BB765291.
func StatusFault(value StatusFault_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: StatusFault_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type StatusJammed_Type uint8

const StatusJammed_NotJammed = StatusJammed_Type(0)
const StatusJammed_Jammed = StatusJammed_Type(1)

var StatusJammed_Meta = Metadata[uint8]{
	Typ: "78",
}

// StatusJammed represents a Status Jammed characteristic (78)
//
// UUID: 00000078-0000-1000-8000-0026BB765291.
func StatusJammed(value StatusJammed_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: StatusJammed_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type StatusLowBattery_Type uint8

const StatusLowBattery_BatteryLevelNormal = StatusLowBattery_Type(0)
const StatusLowBattery_BatteryLevelLow = StatusLowBattery_Type(1)

var StatusLowBattery_Meta = Metadata[uint8]{
	Typ: "79",
}

// StatusLowBattery represents a Status Low Battery characteristic (79)
//
// UUID: 00000079-0000-1000-8000-0026BB765291.
func StatusLowBattery(value StatusLowBattery_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: StatusLowBattery_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type StatusTampered_Type uint8

const StatusTampered_NotTampered = StatusTampered_Type(0)
const StatusTampered_Tampered = StatusTampered_Type(1)

var StatusTampered_Meta = Metadata[uint8]{
	Typ: "7A",
}

// StatusTampered represents a Status Tampered characteristic (7A)
//
// UUID: 0000007A-0000-1000-8000-0026BB765291.
func StatusTampered(value StatusTampered_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: StatusTampered_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}


// StreamingStatus represents a Streaming Status characteristic (120)
//
// UUID: 00000120-0000-1000-8000-0026BB765291.
func StreamingStatus(value StreamingStatusResponse) *UpdatableTLV8[StreamingStatusResponse] {
	static := StaticTLV8[StreamingStatusResponse]{
		Typ:   "120",
		value: value,
	}
	return &UpdatableTLV8[StreamingStatusResponse]{
		StaticTLV8: static,
	}
}

var SulphurDioxideDensity_Meta = Metadata[float64]{
	Typ: "C5",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](1000),
	MinStep: 1,
}

// SulphurDioxideDensity represents a Sulphur Dioxide Density characteristic (C5)
//
// UUID: 000000C5-0000-1000-8000-0026BB765291.
func SulphurDioxideDensity(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: SulphurDioxideDensity_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}


// SupportedAudioStreamConfiguration represents a Supported Audio Stream Configuration characteristic (115)
//
// UUID: 00000115-0000-1000-8000-0026BB765291.
func SupportedAudioStreamConfiguration(value SupportedAudioStreamConfigurationResponse) StaticTLV8[SupportedAudioStreamConfigurationResponse] {
	static := StaticTLV8[SupportedAudioStreamConfigurationResponse]{
		Typ:   "115",
		value: value,
	}
	return static
}


// SupportedRTPConfiguration represents a Supported RTP Configuration characteristic (116)
//
// UUID: 00000116-0000-1000-8000-0026BB765291.
func SupportedRTPConfiguration(value SupportedRTPConfigurationResponse) StaticTLV8[SupportedRTPConfigurationResponse] {
	static := StaticTLV8[SupportedRTPConfigurationResponse]{
		Typ:   "116",
		value: value,
	}
	return static
}


// SupportedVideoStreamConfiguration represents a Supported Video Stream Configuration characteristic (114)
//
// UUID: 00000114-0000-1000-8000-0026BB765291.
func SupportedVideoStreamConfiguration(value SupportedVideoStreamConfigurationResponse) StaticTLV8[SupportedVideoStreamConfigurationResponse] {
	static := StaticTLV8[SupportedVideoStreamConfigurationResponse]{
		Typ:   "114",
		value: value,
	}
	return static
}

type SwingMode_Type uint8

const SwingMode_SwingDisabled = SwingMode_Type(0)
const SwingMode_SwingEnabled = SwingMode_Type(1)

var SwingMode_Meta = Metadata[uint8]{
	Typ: "B6",
}

// SwingMode represents a Swing Mode characteristic (B6)
//
// UUID: 000000B6-0000-1000-8000-0026BB765291.
func SwingMode(value SwingMode_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: SwingMode_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type TargetAirPurifierState_Type uint8

const TargetAirPurifierState_Manual = TargetAirPurifierState_Type(0)
const TargetAirPurifierState_Auto = TargetAirPurifierState_Type(1)

var TargetAirPurifierState_Meta = Metadata[uint8]{
	Typ: "A8",
}

// TargetAirPurifierState represents a Target Air Purifier State characteristic (A8)
//
// UUID: 000000A8-0000-1000-8000-0026BB765291.
func TargetAirPurifierState(value TargetAirPurifierState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetAirPurifierState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type TargetAirQuality_Type uint8

const TargetAirQuality_Excellent = TargetAirQuality_Type(0)
const TargetAirQuality_Good = TargetAirQuality_Type(1)
const TargetAirQuality_Fair = TargetAirQuality_Type(2)

var TargetAirQuality_Meta = Metadata[uint8]{
	Typ: "AE",
}

// TargetAirQuality represents a Target Air Quality characteristic (AE)
//
// UUID: 000000AE-0000-1000-8000-0026BB765291.
func TargetAirQuality(value TargetAirQuality_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetAirQuality_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type TargetDoorState_Type uint8

const TargetDoorState_Open = TargetDoorState_Type(0)
const TargetDoorState_Closed = TargetDoorState_Type(1)

var TargetDoorState_Meta = Metadata[uint8]{
	Typ: "32",
}

// TargetDoorState represents a Target Door State characteristic (32)
//
// UUID: 00000032-0000-1000-8000-0026BB765291.
func TargetDoorState(value TargetDoorState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetDoorState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type TargetFanState_Type uint8

const TargetFanState_Manual = TargetFanState_Type(0)
const TargetFanState_Auto = TargetFanState_Type(1)

var TargetFanState_Meta = Metadata[uint8]{
	Typ: "BF",
}

// TargetFanState represents a Target Fan State characteristic (BF)
//
// UUID: 000000BF-0000-1000-8000-0026BB765291.
func TargetFanState(value TargetFanState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetFanState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type TargetHeaterCoolerState_Type uint8

const TargetHeaterCoolerState_Auto = TargetHeaterCoolerState_Type(0)
const TargetHeaterCoolerState_Heat = TargetHeaterCoolerState_Type(1)
const TargetHeaterCoolerState_Cool = TargetHeaterCoolerState_Type(2)

var TargetHeaterCoolerState_Meta = Metadata[uint8]{
	Typ: "B2",
}

// TargetHeaterCoolerState represents a Target Heater Cooler State characteristic (B2)
//
// UUID: 000000B2-0000-1000-8000-0026BB765291.
func TargetHeaterCoolerState(value TargetHeaterCoolerState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetHeaterCoolerState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type TargetHeatingCoolingState_Type uint8

const TargetHeatingCoolingState_Off = TargetHeatingCoolingState_Type(0)
const TargetHeatingCoolingState_Heat = TargetHeatingCoolingState_Type(1)
const TargetHeatingCoolingState_Cool = TargetHeatingCoolingState_Type(2)
const TargetHeatingCoolingState_Auto = TargetHeatingCoolingState_Type(3)

var TargetHeatingCoolingState_Meta = Metadata[uint8]{
	Typ: "33",
}

// TargetHeatingCoolingState represents a Target Heating Cooling State characteristic (33)
//
// UUID: 00000033-0000-1000-8000-0026BB765291.
func TargetHeatingCoolingState(value TargetHeatingCoolingState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetHeatingCoolingState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

var TargetHorizontalTiltAngle_Meta = Metadata[int32]{
	Typ: "7B",
	Unit: "arcdegrees",
	MinValue: ValuePointer[int32](-90),
	MaxValue: ValuePointer[int32](90),
	MinStep: 1,
}

// TargetHorizontalTiltAngle represents a Target Horizontal Tilt Angle characteristic (7B)
//
// UUID: 0000007B-0000-1000-8000-0026BB765291.
func TargetHorizontalTiltAngle(value int32, controllerWrite func(int32) error) *Writable[int32] {
	static := Static[int32]{
		Metadata: TargetHorizontalTiltAngle_Meta,
		value:    value,
	}
	return &Writable[int32]{
		Updatable: Updatable[int32]{Static: static},
		write: controllerWrite,
	}
}

type TargetHumidifierDehumidifierState_Type uint8

const TargetHumidifierDehumidifierState_HumidifierOrDehumidifier = TargetHumidifierDehumidifierState_Type(0)
const TargetHumidifierDehumidifierState_Humidifier = TargetHumidifierDehumidifierState_Type(1)
const TargetHumidifierDehumidifierState_Dehumidifier = TargetHumidifierDehumidifierState_Type(2)

var TargetHumidifierDehumidifierState_Meta = Metadata[uint8]{
	Typ: "B4",
}

// TargetHumidifierDehumidifierState represents a Target Humidifier Dehumidifier State characteristic (B4)
//
// UUID: 000000B4-0000-1000-8000-0026BB765291.
func TargetHumidifierDehumidifierState(value TargetHumidifierDehumidifierState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetHumidifierDehumidifierState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

var TargetPosition_Meta = Metadata[uint8]{
	Typ: "7C",
	Unit: "percentage",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](100),
	MinStep: 1,
}

// TargetPosition represents a Target Position characteristic (7C)
//
// UUID: 0000007C-0000-1000-8000-0026BB765291.
func TargetPosition(value uint8, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetPosition_Meta,
		value:    value,
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

var TargetRelativeHumidity_Meta = Metadata[float64]{
	Typ: "34",
	Unit: "percentage",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
	MinStep: 1,
}

// TargetRelativeHumidity represents a Target Relative Humidity characteristic (34)
//
// UUID: 00000034-0000-1000-8000-0026BB765291.
func TargetRelativeHumidity(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: TargetRelativeHumidity_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

type TargetSlatState_Type uint8

const TargetSlatState_Manual = TargetSlatState_Type(0)
const TargetSlatState_Auto = TargetSlatState_Type(1)

var TargetSlatState_Meta = Metadata[uint8]{
	Typ: "BE",
}

// TargetSlatState represents a Target Slat State characteristic (BE)
//
// UUID: 000000BE-0000-1000-8000-0026BB765291.
func TargetSlatState(value TargetSlatState_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TargetSlatState_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

var TargetTemperature_Meta = Metadata[float64]{
	Typ: "35",
	Unit: "celsius",
	MinValue: ValuePointer[float64](10),
	MaxValue: ValuePointer[float64](38),
	MinStep: 0.1,
}

// TargetTemperature represents a Target Temperature characteristic (35)
//
// UUID: 00000035-0000-1000-8000-0026BB765291.
func TargetTemperature(value float64, controllerWrite func(float64) error) *Writable[float64] {
	static := Static[float64]{
		Metadata: TargetTemperature_Meta,
		value:    value,
	}
	return &Writable[float64]{
		Updatable: Updatable[float64]{Static: static},
		write: controllerWrite,
	}
}

var TargetTiltAngle_Meta = Metadata[int32]{
	Typ: "C2",
	Unit: "arcdegrees",
	MinValue: ValuePointer[int32](-90),
	MaxValue: ValuePointer[int32](90),
	MinStep: 1,
}

// TargetTiltAngle represents a Target Tilt Angle characteristic (C2)
//
// UUID: 000000C2-0000-1000-8000-0026BB765291.
func TargetTiltAngle(value int32, controllerWrite func(int32) error) *Writable[int32] {
	static := Static[int32]{
		Metadata: TargetTiltAngle_Meta,
		value:    value,
	}
	return &Writable[int32]{
		Updatable: Updatable[int32]{Static: static},
		write: controllerWrite,
	}
}

var TargetVerticalTiltAngle_Meta = Metadata[int32]{
	Typ: "7D",
	Unit: "arcdegrees",
	MinValue: ValuePointer[int32](-90),
	MaxValue: ValuePointer[int32](90),
	MinStep: 1,
}

// TargetVerticalTiltAngle represents a Target Vertical Tilt Angle characteristic (7D)
//
// UUID: 0000007D-0000-1000-8000-0026BB765291.
func TargetVerticalTiltAngle(value int32, controllerWrite func(int32) error) *Writable[int32] {
	static := Static[int32]{
		Metadata: TargetVerticalTiltAngle_Meta,
		value:    value,
	}
	return &Writable[int32]{
		Updatable: Updatable[int32]{Static: static},
		write: controllerWrite,
	}
}

type TemperatureDisplayUnits_Type uint8

const TemperatureDisplayUnits_Celsius = TemperatureDisplayUnits_Type(0)
const TemperatureDisplayUnits_Fahrenheit = TemperatureDisplayUnits_Type(1)

var TemperatureDisplayUnits_Meta = Metadata[uint8]{
	Typ: "36",
}

// TemperatureDisplayUnits represents a Temperature Display Units characteristic (36)
//
// UUID: 00000036-0000-1000-8000-0026BB765291.
func TemperatureDisplayUnits(value TemperatureDisplayUnits_Type, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: TemperatureDisplayUnits_Meta,
		value:    uint8(value),
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type ValveType_Type uint8

const ValveType_GenericValve = ValveType_Type(0)
const ValveType_Irrigation = ValveType_Type(1)
const ValveType_ShowerHead = ValveType_Type(2)
const ValveType_WaterFaucet = ValveType_Type(3)

var ValveType_Meta = Metadata[uint8]{
	Typ: "D5",
}

// ValveType represents a Valve Type characteristic (D5)
//
// UUID: 000000D5-0000-1000-8000-0026BB765291.
func ValveType(value ValveType_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: ValveType_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

var Version_Meta = Metadata[string]{
	Typ: "37",
}

// Version represents a Version characteristic (37)
//
// UUID: 00000037-0000-1000-8000-0026BB765291.
func Version(value string) *Updatable[string] {
	static := Static[string]{
		Metadata: Version_Meta,
		value:    value,
	}
	return &Updatable[string]{
		Static: static,
	}
}

var VOCDensity_Meta = Metadata[float64]{
	Typ: "C8",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](1000),
	MinStep: 1,
}

// VOCDensity represents a VOC Density characteristic (C8)
//
// UUID: 000000C8-0000-1000-8000-0026BB765291.
func VOCDensity(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: VOCDensity_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}

var Volume_Meta = Metadata[uint8]{
	Typ: "119",
	Unit: "percentage",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](100),
	MinStep: 1,
}

// Volume represents a Volume characteristic (119)
//
// UUID: 00000119-0000-1000-8000-0026BB765291.
func Volume(value uint8, controllerWrite func(uint8) error) *Writable[uint8] {
	static := Static[uint8]{
		Metadata: Volume_Meta,
		value:    value,
	}
	return &Writable[uint8]{
		Updatable: Updatable[uint8]{Static: static},
		write: controllerWrite,
	}
}

type VolumeControlType_Type uint8

const VolumeControlType_None = VolumeControlType_Type(0)
const VolumeControlType_Relative = VolumeControlType_Type(1)
const VolumeControlType_RelativeWithCurrent = VolumeControlType_Type(2)
const VolumeControlType_Absolute = VolumeControlType_Type(3)

var VolumeControlType_Meta = Metadata[uint8]{
	Typ: "E9",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](3),
	MinStep: 1,
}

// VolumeControlType represents a Volume Control Type characteristic (E9)
//
// UUID: 000000E9-0000-1000-8000-0026BB765291.
func VolumeControlType(value VolumeControlType_Type) *Updatable[uint8] {
	static := Static[uint8]{
		Metadata: VolumeControlType_Meta,
		value:    uint8(value),
	}
	return &Updatable[uint8]{
		Static: static,
	}
}

type VolumeSelector_Type uint8

const VolumeSelector_Increment = VolumeSelector_Type(0)
const VolumeSelector_Decrement = VolumeSelector_Type(1)

var VolumeSelector_Meta = Metadata[uint8]{
	Typ: "EA",
	MinValue: ValuePointer[uint8](0),
	MaxValue: ValuePointer[uint8](1),
	MinStep: 1,
}

// VolumeSelector represents a Volume Selector characteristic (EA)
//
// UUID: 000000EA-0000-1000-8000-0026BB765291.
func VolumeSelector(controllerWrite func(uint8) error) WriteOnly[uint8] {
	return WriteOnly[uint8]{
		Metadata: VolumeSelector_Meta,
		write:    controllerWrite,
	}
}

var WaterLevel_Meta = Metadata[float64]{
	Typ: "B5",
	Unit: "percentage",
	MinValue: ValuePointer[float64](0),
	MaxValue: ValuePointer[float64](100),
}

// WaterLevel represents a Water Level characteristic (B5)
//
// UUID: 000000B5-0000-1000-8000-0026BB765291.
func WaterLevel(value float64) *Updatable[float64] {
	static := Static[float64]{
		Metadata: WaterLevel_Meta,
		value:    value,
	}
	return &Updatable[float64]{
		Static: static,
	}
}


// SupportedCameraRecordingConfiguration represents a Supported Camera Recording Configuration characteristic (205)
//
// UUID: 00000205-0000-1000-8000-0026BB765291.
func SupportedCameraRecordingConfiguration(value SupportedCameraRecordingConfigurationResponse) *UpdatableTLV8[SupportedCameraRecordingConfigurationResponse] {
	static := StaticTLV8[SupportedCameraRecordingConfigurationResponse]{
		Typ:   "205",
		value: value,
	}
	return &UpdatableTLV8[SupportedCameraRecordingConfigurationResponse]{
		StaticTLV8: static,
	}
}


// SupportedVideoRecordingConfiguration represents a Supported Video Recording Configuration characteristic (206)
//
// UUID: 00000206-0000-1000-8000-0026BB765291.
func SupportedVideoRecordingConfiguration(value SupportedVideoRecordingConfigurationResponse) *UpdatableTLV8[SupportedVideoRecordingConfigurationResponse] {
	static := StaticTLV8[SupportedVideoRecordingConfigurationResponse]{
		Typ:   "206",
		value: value,
	}
	return &UpdatableTLV8[SupportedVideoRecordingConfigurationResponse]{
		StaticTLV8: static,
	}
}


// SupportedAudioRecordingConfiguration represents a Supported Audio Recording Configuration characteristic (207)
//
// UUID: 00000207-0000-1000-8000-0026BB765291.
func SupportedAudioRecordingConfiguration(value SupportedAudioRecordingConfigurationResponse) *UpdatableTLV8[SupportedAudioRecordingConfigurationResponse] {
	static := StaticTLV8[SupportedAudioRecordingConfigurationResponse]{
		Typ:   "207",
		value: value,
	}
	return &UpdatableTLV8[SupportedAudioRecordingConfigurationResponse]{
		StaticTLV8: static,
	}
}


// SelectedCameraRecordingConfiguration represents a Selected Camera Recording Configuration characteristic (209)
//
// UUID: 00000209-0000-1000-8000-0026BB765291.
func SelectedCameraRecordingConfiguration(value SelectedCameraRecordingConfigurationResponse, controllerWrite func(SelectedCameraRecordingConfigurationRequest) (SelectedCameraRecordingConfigurationResponse, error)) *WritableTLV8[SelectedCameraRecordingConfigurationRequest, SelectedCameraRecordingConfigurationResponse] {
	static := StaticTLV8[SelectedCameraRecordingConfigurationResponse]{
		Typ:   "209",
		value: value,
	}
	return &WritableTLV8[SelectedCameraRecordingConfigurationRequest, SelectedCameraRecordingConfigurationResponse]{
		UpdatableTLV8: UpdatableTLV8[SelectedCameraRecordingConfigurationResponse]{StaticTLV8: static},
		write: controllerWrite,
	}
}
